<?php
//  require('/home/html/lib/template.php');
//  $template_vars['title'] = 'Cross Stitch Wizard';

  require('config.php');
  set_time_limit(0);
  ini_set('memory_limit', '16M');

  $width = 80;
  $colors = 32;

  if(isset($_POST['width'])) $width = max(10, $_POST['width']);
  if(isset($_POST['colors'])) $colors = max(2, $_POST['colors']);
  if(isset($_POST['brand'])) $brand = $_POST['brand']; else $brand = DMC_BRAND;

  if(isset($_FILES['image']))
  {
    output($_FILES['image']['tmp_name'], $width, $colors, $brand);
  }
  else
  {
    $html = <<<EOD
<center>
<div style="width:500px;text-align:left;background-image: url(cs.png);border:thin solid"><div style="margin:15px">
<form method="post" action="index.php" enctype="multipart/form-data">
<input type="hidden" name="MAX_FILE_SIZE" value="2097152" />

<p>Welcome to the online cross stitch creator!</p>
<p>To create a cross stitch, upload a JPEG file. You can specify
the width of the pattern to be created, as well as the number of colors desired.</p>

<p>Please have patience, my server is a senior citizen.</p>

<p>Please adjust the pictures brightness and contrast, crop, and
any other image editing before you upload the picture. The cross stitch wizard does
not attempt to provide image editing capabilities.</p>

<table><tr><td align="left">JPEG file:</td><td align="left"><input type="file" name="image"/></td></tr>
<tr><td align="left">Pattern width:</td>
<td align="left"><input type="text" size="5" name="width" value="$width"/></td></tr>
<tr><td align="left">Pattern colors:</td>
<td align="left"><input type="text" size="5" name="colors" value="$colors"/></td></tr>
<tr><td align="left">Brand of thread:</td>
<td align="left"><select name="brand">
<option value="3">DMC</option>
<option value="4">ANCHOR</option>
<option value="5">SEMCO</option>
<option value="6">MADEIRA</option>
<option value="7">J&amp;P</option>
</select></td></tr>
<tr><td colspan="2"><input type="submit" value="Create!"/></td></tr></table>
</form><br /><a href="cross_stitch.2.tgz">Source</a><br /></div></div></center>
EOD;
    echo $html;

  }

  function output($imgfile, $width, $maxcolors, $brand)
  {
    @copy($imgfile, 'cache/orig/' . basename($imgfile) . '.jpg');

    global $colours, $brands;
    $img = imagecreatefromjpeg($imgfile);
    $width = min($width, imagesx($img));

    if($width == 0)
    {
      echo "Unable to open image file<br />\n";
      return;
    }

    $height = floor(imagesy($img) * $width / imagesx($img));

    $id = uniqid('csw');

    // resize
    $q = imagecreatetruecolor($width, $height);
    imagecopyresampled($q, $img, 0, 0, 0, 0, $width, $height, imagesx($img), imagesy($img));  
    imagedestroy($img);
    $img = $q;

    // limit colors
    $good = $maxcolors;
    $best = 0;
    for($colors = $maxcolors; $colors < 256; $colors++)
    {
      $colorlist = array();
      $q = imagecreatetruecolor($width, $height);
      imagecopy($q, $img, 0, 0, 0, 0, $width, $height);

      ImageTrueColorToPalette($q, false, $colors);
      $tc = imagecolorstotal($q);
      for($i = 0; $i < $tc; $i++)
      {
        $c = imagecolorsforindex($q, $i);
        $c = nearest_rgb($c['red'], $c['green'], $c['blue'], $brand);
        $colorlist[$c] = $c;
        list($r, $g, $b) = $colours[$c];
        imagecolorset($q, $i, $r, $g, $b);
      }
      $c = count($colorlist);
      if($c <= $maxcolors && $c > $best)
      {
        $good = $colors;
        $best = $c;
        if(isset($save)) imagedestroy($save);
        $save = $q;
        $cm = $colorlist;
        $colors += $maxcolors - $c - 1;
      }
      else
        imagedestroy($q);
      if($c - 2 > $maxcolors) break;
    }

    // generate preview
    $img = imagecreate($width * 5, $height * 5);
    imagecopyresized($img, $save, 0, 0, 0, 0, $width*5, $height*5, $width, $height);
    imagepng($img, "cache/$id.png");
    echo "<img border=\"1\" src=\"cache/$id.png\"/><br/>\n";

    // display colors
    $i = 0;
    echo "<br/>{$brands[$brand]} Threads:<br/>\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" style=\"page-break-before:always\">\n";
    foreach($cm as $name)
    {
      $i++;
      list($r, $g, $b) = $colours[$name];
      $bg = str_pad(dechex($r), 2, '0', STR_PAD_LEFT) . str_pad(dechex($g), 2, '0', STR_PAD_LEFT) . str_pad(dechex($b), 2, '0', STR_PAD_LEFT);
      echo "<tr><td style=\"border:thin solid;width:100px\">#{$colours[$name][$brand]}</td>";
      echo "<td style=\"border:thin solid;width:20px;text-align:center\">";
      echo "<img src=\"symbols/{$colours[$name][8]}.png\" width=\"22\" height=\"22\" alt=\"#{$colours[$name][$brand]}\"/></td>";
      echo "<td style=\"border:thin solid;width:20px\" bgcolor=\"#$bg\">&nbsp;</td><td>&nbsp; $name</td></tr>\n";
      $cmi[$name] = $i;
    }
    echo "</table><br/><br/>\n";

    $hsize = 25;
    $vsize = 35;

    echo "<p><b>Blocks</b></p>\n";
    echo "<table border=\"1\">\n";
    $i = 0;
    for($y = 0; $y < $height; $y += $vsize)
    {
      echo "<tr>";
      for($x = 0; $x < $width; $x+= $hsize)
      {
        $i++;
        echo "<td>$i</td>\n";
      }
      echo "</tr>";
    }
    echo "</table><br/><br/>\n";

    $i = 0;
    for($y = 0; $y < $height; $y += $vsize)
    {
      for($x = 0; $x < $width; $x+= $hsize)
      {
        $i++;
        draw_map($save, $x, $y, min($width, $x + $hsize), min($height, $y + $vsize), "Block $i", $brand);
      }
    }
  }

  function draw_map($img, $sx, $sy, $ex, $ey, $caption, $brand)
  {
    global $colours;
    echo "<table style=\"border:thin solid; font-size:14px; page-break-before:always\" cellspacing=\"0\" cellpadding=\"0\" border=\"1\">\n";
    echo "<tr><th colspan=\"".($ey-$sy)."\">$caption</td></tr>\n";
    for($y = $sy; $y < $ey; $y++)
    {
      echo "<tr>";
      for($x = $sx; $x < $ex; $x++)
      {
        $c = imagecolorat($img, $x, $y);
        $c = imagecolorsforindex($img, $c);
        $c = nearest_rgb($c['red'], $c['green'], $c['blue'], $brand);
        echo "<td style=\"width:24px;height:24px\" align=\"center\" valign=\"center\">";
        echo "<img src=\"symbols/{$colours[$c][8]}.png\" width=\"22\" height=\"22\" alt=\"#{$colours[$c][$brand]}\"/></td>\n";
      }
      echo "</tr>";
    }
    echo "</table>\n<br/><br/>\n";
  }

  function nearest_rgb($r, $g, $b, $brand=DMC_BRAND)
  {
    global $colours;
    static $cache = array();

    if(isset($cache[$r][$g][$b]) && isset($colours[$cache[$r][$g][$b]])) return $cache[$r][$g][$b];

    $closest = 'Black';
    $distance_squared = $r * $r + $g * $g + $b * $b;

    foreach($colours as $name=>$data)
    {
      if($data[$brand] != -1)
      {
        list($r2, $g2, $b2) = $data;
        $r2 -= $r;
        $g2 -= $g;
        $b2 -= $b;
        $d2 = $r2 * $r2 + $g2 * $g2 + $b2 * $b2;
        if($d2 < $distance_squared)
        {
          $closest = $name;
          $distance_squared = $d2;
        }
      }
    }
    $cache[$r][$g][$b] = $closest;
    return $closest;
  }
?>
